
package cl.json.clipboard;

import android.content.ClipboardManager;
import android.content.ClipData;
import android.content.ClipboardManager.OnPrimaryClipChangedListener;
import android.util.Log;
import android.os.Handler;
import android.os.Looper;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.modules.core.DeviceEventManagerModule;

public class RNReactNativeBackgroundClipboardModule extends ReactContextBaseJavaModule {

    private static final String TAG = "OnClipboard";


    private final ReactContext reactContext;
    private ClipboardManager clipboardManager;
    private final ClipboardManager.OnPrimaryClipChangedListener listener = new ClipboardManager.OnPrimaryClipChangedListener(){

        @Override
        public void onPrimaryClipChanged() {
            ClipData contents = clipboardManager.getPrimaryClip();
            String mNeirong = "";
            if (contents != null && contents.getItemCount() > 0) {
                // 从数据集中获取（粘贴）第一条文本数据
                mNeirong = contents.getItemAt(0).getText().toString();
            }
            Log.i(TAG, mNeirong);
            sendEvent(reactContext, "backgroundClipboard", mNeirong);
        }
    };

    public RNReactNativeBackgroundClipboardModule(ReactApplicationContext reactContext) {
        super(reactContext);
        this.reactContext = reactContext;
        Handler handler = new Handler(Looper.getMainLooper());
        handler.post(new Runnable() {
            @Override
            public void run() {
                RNReactNativeBackgroundClipboardModule.this.clipboardManager = (ClipboardManager) getReactApplicationContext().getSystemService(RNReactNativeBackgroundClipboardModule.this.reactContext.CLIPBOARD_SERVICE);
                RNReactNativeBackgroundClipboardModule.this.clipboardManager.addPrimaryClipChangedListener(RNReactNativeBackgroundClipboardModule.this.listener);
            }
        });
        //this.clipboardManager = (ClipboardManager) reactContext.getSystemService(reactContext.CLIPBOARD_SERVICE);

    }

    private void sendEvent(ReactContext reactContext, String eventName, Object eventValue) {
        reactContext
                .getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class)
                .emit(eventName, eventValue);
    }

    @Override
    public String getName() {
        return "RNReactNativeBackgroundClipboard";
    }
}